unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, dbf, Forms, Controls, Graphics, Dialogs, DBGrids,
  StdCtrls, DBCtrls, TAGraph, TASeries, TASources, TAIntervalSources,
  TATransformations, DateUtils, TAChartUtils, TADbSource ;

type

  { TF_Ernte }

  TF_Ernte = class(TForm)
    Btn_Ende : TButton;
    CAT_LinksAutoScaleAxisTransform1 : TAutoScaleAxisTransform;
    CAT_Rechts : TChartAxisTransformations;
    CAT_RechtsAutoScaleAxisTransform1 : TAutoScaleAxisTransform;
    CAT_Links : TChartAxisTransformations;
    Cha_Grafik : TChart;
    Cha_GrafikDurchschnkWh : TLineSeries;
    Cha_GrafikLineSeries1 : TLineSeries;
    Cha_GrafikTaeglkWh : TLineSeries;
    Cha_GrafikSummekWh : TLineSeries;
    Cha_GrafikMedian : TLineSeries;
    DTC_Ernte : TDateTimeIntervalChartSource;
    DBGrid_Preise : TDBGrid;
    DBGrid_Ernte : TDBGrid;
    DBN_Preise : TDBNavigator;
    DBN_Ernte : TDBNavigator;
    Dsc_Strompreis : TDataSource;
    GrB_Ernte : TGroupBox;
    GrB_Preise : TGroupBox;
    GrB_Beschreibung : TGroupBox;
    Label1 : TLabel;
    Lbl_Beschreibung : TLabel;
    Lbl_Titel : TLabel;
    LCS_Taegl : TListChartSource;
    LCS_Durchschn : TListChartSource;
    LCS_Median : TListChartSource;
    LCS_Summe : TListChartSource;
    Strompreis : TDbf;
    Dsc_Stromernte : TDataSource;
    Stromernte : TDbf;
    procedure Btn_EndeClick(Sender : TObject);
    procedure DBN_PreiseClick(Sender : TObject; Button : TDBNavButtonType);
    procedure DBN_ErnteClick(Sender : TObject; Button : TDBNavButtonType);
    procedure FormCreate(Sender : TObject);
    procedure FormResize(Sender : TObject);
    procedure GrafCreate(Sender : TObject);

  private

  public

  end;

var
  F_Ernte : TF_Ernte;

implementation

{$R *.lfm}

{ TF_Ernte }

{*************************************
* ProgEnde
*
**************************************}

procedure TF_Ernte.Btn_EndeClick(Sender : TObject);


begin
  Stromernte.Close;
  Strompreis.close;
  close;
end;                         // procedure TF_Ernte.Btn_EndeClick

{****************************************
* Preis-Navigator
*
*****************************************}

procedure TF_Ernte.DBN_PreiseClick(Sender : TObject; Button : TDBNavButtonType);

var
  BtnName : string = '';     // Name des Kopfes

begin
  case Button of             // die wichtigsten
    nbFirst : begin
                BtnName := 'nbFirst';
               end;           // nbFirst
    nbPrior : begin
                BtnName := 'nbPrior';
              end;           // nbPrior
    nbNext  : begin
                BtnName := 'nbNext';
              end;           // nbNext
    nbLast  : begin
                BtnName := 'nbLast';
              end;
    nbEdit  : begin
                BtnName := 'nbEdit';
              end;
    nbPost  : begin
                BtnName := 'nbPost';
              end;           // nbPost
   nbCancel : begin
                BtnName := 'nbCancel';
              end;
  nbRefresh : begin
                BtnName := 'nbRefresh';
                DBN_Preise.Refresh; // Alle Datensätze neu lesen und Post ausführen
               end;
   nbInsert : begin
                Strompreis.Last;
                Strompreis.Edit;
                Strompreis.Append;
              end;           // nbInsert
   nbDelete : begin
                BtnName := 'nbDelete';
                DBGrid_Preise.Repaint;
                Strompreis.Last;
              end;           // nbDelete
  end;                       // case Button of

end;                         // procedure TF_Ernte.DBN_PreiseClick

{***************************************
* Daten-Navigator
*
****************************************}

procedure TF_Ernte.DBN_ErnteClick(Sender : TObject;
  Button : TDBNavButtonType);

var
  BtnName : string = '';     // Name des Kopfes

begin
  case Button of             // die wichtigsten
    nbFirst : begin
                BtnName := 'nbFirst';
               end;          // nbFirst
    nbPrior : begin
                BtnName := 'nbPrior';
              end;           // nbPrior
    nbNext  : begin
                BtnName := 'nbNext';
              end;           // nbNext
    nbLast  : begin
                BtnName := 'nbLast';
              end;
    nbEdit  : begin
                BtnName := 'nbEdit';
              end;
    nbPost  : begin
                BtnName := 'nbPost';
              end;           // nbPost
   nbCancel : begin
                BtnName := 'nbCancel';
              end;
  nbRefresh : begin
                BtnName := 'nbRefresh';
                DBN_Ernte.Refresh; // Alle Datensätze neu lesen und Post ausführen
               end;
   nbInsert : begin
                Stromernte.Last;
                Stromernte.Edit;
                Stromernte.Append;
              end;           // nbInsert
   nbDelete : begin
                BtnName := 'nbDelete';
                DBGrid_Ernte.Repaint;
                Stromernte.Last;
              end;           // nbDelete
  end;                       // case Button of

end;                         // procedure TF_Ernte.DBN_StromernteClick

{*****************************************
* Grafen erstellen
*
******************************************}

procedure TF_Ernte.GrafCreate(Sender : TObject);

var
  N    : integer = 1;         // Zahl der Datenpunkte
  I    : integer = 1;         // Zähler

begin
  LCS_Taegl.Clear;
  LCS_Durchschn.Clear;
  LCS_Median.Clear;
  LCS_Summe.Clear;

  N := Stromernte.recordcount;
  Stromernte.first;

  DTC_Ernte.DateTimeFormat:='dd.mm.yyyy';
  with Cha_Grafik.BottomAxis do     //BottomAxis und AxisList[1] ist das Gleiche
  begin
    Marks.Source := DTC_Ernte;
    Marks.Style := smsLabel;
//    Range.Min := Stromernte.FieldByName('DATUM').AsDateTime;
//    Range.Max := Range.Min + 64;
    Range.UseMin := false;
    Range.UseMax := false;
    Marks.LabelFont.Orientation:=900; // In 1/10 Grad
  end;

  for I := 1 to N do
  begin
    LCS_Taegl.Add(Stromernte.FieldByName('DATUM').AsDateTime,Stromernte.FieldByName('TAEGL_KWH').AsFloat);
    LCS_Durchschn.Add(Stromernte.FieldByName('DATUM').AsDateTime,Stromernte.FieldByName('DURCHSCHN').AsFloat);
    LCS_Median.Add(Stromernte.FieldByName('DATUM').AsDateTime,Stromernte.FieldByName('MEDIAN').AsFloat);
    LCS_Summe.Add(Stromernte.FieldByName('DATUM').AsDateTime,Stromernte.FieldByName('Summe_KWH').AsFloat);
    Stromernte.next;
  end;                       // for I := 1 to N do

end;                         // procedure TF_Ernte.GrafCreate

{*****************************************
* Form herstellen
*
******************************************}

procedure TF_Ernte.FormCreate(Sender : TObject);

var
  Summe : real = 0.0;
  Datum : TDateTime;
  MJahr : integer = 2022;
  Ertrag : real = 0.0;
  Durchschnitt : real = 0.0;

begin
//  stromernte.FilePathFull := MDBF_Lw;    // Temp2->Debitor vorbereiten
  Stromernte.ReadOnly := false;
  Stromernte.Active := true;
//  Stromernte.IndexName := 'DE_Nummer';   // Indexnamen zuweisen
  Stromernte.Open;
  Stromernte.First;

  Strompreis.ReadOnly := false;
  Strompreis.Active := true;
  Strompreis.Open;
  Strompreis.First;

  DBGrid_Ernte.Columns[0].Title.Caption := 'Datum';
  DBGrid_Ernte.Columns[0].Width := 65;
  DBGrid_Ernte.Columns[1].Title.Caption := 'Tägl. kWh';
  DBGrid_Ernte.Columns[1].Width := 60;
  DBGrid_Ernte.Columns[1].Displayformat := '0.00';
  DBGrid_Ernte.Columns[2].Title.Caption := 'Summe kWh';
  DBGrid_Ernte.Columns[2].Width := 75;
  DBGrid_Ernte.Columns[2].Displayformat := '####0.00';
  DBGrid_Ernte.Columns[2].ReadOnly := true;
  DBGrid_Ernte.Columns[3].Title.Caption := 'Ertag [€]';
  DBGrid_Ernte.Columns[3].Width := 50;
  DBGrid_Ernte.Columns[3].Displayformat := '####0.00';
  DBGrid_Ernte.Columns[3].ReadOnly := true;
  DBGrid_Ernte.Columns[4].Title.Caption := 'Ø-kWh';
  DBGrid_Ernte.Columns[4].Width := 45;
  DBGrid_Ernte.Columns[4].Displayformat := '0.00';
  DBGrid_Ernte.Columns[4].ReadOnly := true;
  DBGrid_Ernte.Columns[5].Title.Caption := 'Median-kWh';
  DBGrid_Ernte.Columns[5].Width := 75;
  DBGrid_Ernte.Columns[5].Displayformat := '0.00';
  DBGrid_Ernte.Columns[5].ReadOnly := true;
  DBGrid_Ernte.Columns[6].Title.Caption := 'Bemerkungen';
  DBGrid_Ernte.Columns[6].Width := 100;


  DBGrid_Preise.Columns[0].Title.Caption := 'Jahr';
  DBGrid_Preise.Columns[0].Width := 40;
  DBGrid_Preise.Columns[1].Title.Caption := 'Preis / kWh';
  DBGrid_Preise.Columns[1].Width := 60;
  DBGrid_Preise.Columns[1].Displayformat := '0.0000';

  GrafCreate(Sender);

  Strompreis.last;
  Stromernte.last;

end;                         // procedure TF_Ernte.FormCreate

{***************************************
* Größen und Positionen definieren
*
****************************************}

procedure TF_Ernte.FormResize(Sender : TObject);

begin
  F_Ernte.Width  := 1600;
  F_Ernte.Height := 800;
  F_Ernte.Top    := 150;
  F_Ernte.Left   := 150;

  Btn_Ende.Left := F_Ernte.Width - 10 - 75;
  Btn_Ende.Top  := F_Ernte.Height - 10 - 25;

  GrB_Ernte.Top    := Cha_Grafik.Top + Cha_Grafik.Height + 10;
  GrB_Ernte.Left   := 5;
  GrB_Ernte.Height := 245;

  GrB_Preise.Top    := GrB_Ernte.Top;
  GrB_Preise.Left   := GrB_Ernte.Left + GrB_Ernte.Width + 10;
  GrB_Preise.Height := GrB_Ernte.Height;

  Lbl_Titel.Top   := 10;
  Lbl_Titel.Left  := round((F_Ernte.Width - Lbl_Titel.Width) / 2);

  GrB_Beschreibung.Top    := GrB_Ernte.Top;
  GrB_Beschreibung.Left   := GrB_Preise.Left + GrB_Preise.Width + 10;
  GrB_Beschreibung.Height := GrB_Ernte.Height - 50;

  DBN_Ernte.Top := DBGrid_Ernte.Height + 10;
  DBN_Preise.Top := DBN_Ernte.Top;


end;                         // procedure TF_Ernte.FormResize

end.

